/*
 ============================================================================
 Name        : main.c
 Author      : Phil Hertha
 Version     :
 Copyright   : Copyright belongs to the authors
 Description : Hello World in C
 ============================================================================
 */

#include <stdio.h>
#include "cpu_core.h"
#include "ucos_ii.h"
#include "ucos_bsp.h"
#include "xil_types.h"

extern void startAPP(void);

#define MAIN_TASK_STACK_SIZE 192	// before optimization: 256 --> reduction by 25%
static CPU_STK mainTaskStk[MAIN_TASK_STACK_SIZE];

int printf(const char *x, ...) {return 0;}
int puts(const char *x) {return 0;}
void xil_printf( const char8 *ctrl1, ...){}

void mainTask(void * p_arg) {
	(void) p_arg;

	UCOS_StartupInit();
	UCOS_TmrTickInit(OS_TICKS_PER_SEC);

	//OSStatInit();

	startAPP();

	OSTaskSuspend(OS_PRIO_SELF);

	//Should never get here
	while (1);;
}

int main(void) {
	UCOS_LowLevelInit();
	CPU_Init();
	OSInit();

	OSTaskCreateExt( mainTask,
	                    NULL,
	                    &mainTaskStk[MAIN_TASK_STACK_SIZE - 1],
	                    0,
	                    0,
	                    &mainTaskStk[0],
						MAIN_TASK_STACK_SIZE,
	                     DEF_NULL,
	                    (OS_TASK_OPT_STK_CLR | OS_TASK_OPT_STK_CHK));

	OSTaskNameSet(0,(INT8U *)"mainTask",NULL);
	OSStart();

	//Should never get here
	while (1);;
}
