/*
*********************************************************************************************************
*                                             uCOS XSDK BSP
*
*                    Copyright 2014-2020 Silicon Laboratories Inc. www.silabs.com
*
*                                 SPDX-License-Identifier: APACHE-2.0
*
*               This software is subject to an open source license and is distributed by
*                Silicon Laboratories Inc. pursuant to the terms of the Apache License,
*                    Version 2.0 available at www.apache.org/licenses/LICENSE-2.0.
*
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                 USB HOST APPLICATION INITIALIZATION
*
* File : app_usbh.c
*********************************************************************************************************
*/

/*
*********************************************************************************************************
*                                             INCLUDE FILES
*********************************************************************************************************
*/

#define   APP_USBH_MODULE

#include  <ucos_bsp.h>
#include  "app_usbh.h"

/*
*********************************************************************************************************
*                                              LOCAL DEFINES
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                         LOCAL GLOBAL VARIABLES
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                        LOCAL FUNCTION PROTOTYPES
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                       LOCAL CONFIGURATION ERRORS
*********************************************************************************************************
*/


/*
*********************************************************************************************************
*                                            App_USBH_Init()
*
* Description : Initialize USB Host Stack and additional demos.
*
* Argument(s) : None.
*
* Return(s)   : DEF_OK      if successfull.
*               DEF_FAIL    otherwise.
*
* Caller(s)   : Application.
*
* Note(s)     : None.
*********************************************************************************************************
*/

CPU_BOOLEAN  App_USBH_Init (void)
{
    USBH_ERR    err;

    UCOS_Printf("... Initiliazing HOST Mass Storage class ...\r\n");
    err = App_USBH_MSC_Init();\

    if (err != USBH_ERR_NONE) {
    	UCOS_Printf("...could not initialize HOST Mass Storage Class w/err = %d\r\n\r\n", err);
        return (DEF_FAIL);
    }


    return (DEF_OK);
}
